searchNodes=[{"ref":"GitDiff.html","title":"GitDiff","type":"module","doc":"A simple implementation for taking the output from &#39;git diff&#39; and transforming it into Elixir structs. Installation The package can be installed by adding git_diff to your list of dependencies in mix.exs: def deps do [ {:git_diff, &quot;~&gt; 0.6.1&quot;} ] end Example Output: [ %GitDiff.Patch{ chunks: [ %GitDiff.Chunk{ from_num_lines: &quot;42&quot;, from_start_line: &quot;42&quot;, header: &quot;@@ -481,23 +483,24 @@ class Cursor extends Model {&quot; context: &quot;class Cursor extends Model {&quot;, # will be &quot;&quot; if there is no context lines: [ %GitDiff.Line{ from_line_number: 481, text: &quot; {&quot;, to_line_number: 483, type: :context # will be one of :context, :add, :remove }, ... ], to_num_lines: &quot;42&quot;, to_start_line: &quot;42&quot; } ], from: &quot;src/cursor.js&quot;, headers: %{&quot;index&quot; =&gt; {&quot;10bdef8&quot;, &quot;181eeb9&quot;, &quot;100644&quot;}}, to: &quot;src/cursor.js&quot;}, ] The above output is heavily truncated for illustration, but it should give enough of an idea of what to expect. The code, while naive, is less than 100 lines of actual code and all takes place in the GitDiff module. Emulate the tests in a an interactive shell for quick viewing of the output. Benchmarks Haven&#39;t done much benchmarking, but up to around a 5k (I just stopped trying there) line diff the performance was linear and took a whopping 35ms per call on the test VM. For a more reasonably sized ~150 line diff it clocked in at around 340 microseconds."},{"ref":"GitDiff.html#parse_patch/2","title":"GitDiff.parse_patch/2","type":"function","doc":"Parse the output from a &#39;git diff&#39; command. Returns {:ok, [%GitDiff.Patch{}]} for success, {:error, :unrecognized_format} otherwise. See GitDiff.Patch."},{"ref":"GitDiff.html#stream_patch/2","title":"GitDiff.stream_patch/2","type":"function","doc":"Parse the output from a &#39;git diff&#39; command. Like parse_patch/1 but takes an Enumerable of lines and returns a stream of {:ok, %GitDiff.Patch{}} for successfully parsed patches or {:error, _} if the patch failed to parse."},{"ref":"GitDiff.Chunk.html","title":"GitDiff.Chunk","type":"module","doc":"Every patch generated by a &#39;git diff&#39; command contains one or more chunks"},{"ref":"GitDiff.Chunk.html#t:t/0","title":"GitDiff.Chunk.t/0","type":"type","doc":"Defines the Chunk struct. :from_start_line - The line at which this chunk began preimage. :to_start_line - The line at which this chunk began postimages. :from_num_lines - The number of lines in the file preimage. :to_num_lines - The number of lines in the file postimages. :header - The header indicating the format and the file names. :lines - The lines of text contained within this chunk of changes. See GitDiff.Line. :context - The extracted context from the header if there is one. A blank string otherwise."},{"ref":"GitDiff.Line.html","title":"GitDiff.Line","type":"module","doc":"Every chunk contains multiple lines, which can be context, added, or removed lines."},{"ref":"GitDiff.Line.html#__struct__/0","title":"GitDiff.Line.__struct__/0","type":"function","doc":"Defines the Line struct. :from_line_number - The line number preimage. :to_line_number - The line number postimages. :text - The text of this line. :type - The extracted type of line. One of :context, :add, or :remove."},{"ref":"GitDiff.Line.html#t:t/0","title":"GitDiff.Line.t/0","type":"type","doc":"Defines the Line struct. :from_line_number - The line number preimage. :to_line_number - The line number postimages. :text - The text of this line. :type - The extracted type of line. One of :context, :add, or :remove."},{"ref":"GitDiff.Patch.html","title":"GitDiff.Patch","type":"module","doc":"Every &#39;git diff&#39; command generates one or more patches."},{"ref":"GitDiff.Patch.html#__struct__/0","title":"GitDiff.Patch.__struct__/0","type":"function","doc":"Defines the Patch struct. :from - The file name preimage. :to - The file name postimages. :headers - A list of headers for the patch. :chunks - A list of chunks of changes contained in this patch. See GitDiff.Chunk."}]